module Ecoportal
  module API
    class V2
      class Page
        class Stages < Common::Content::CollectionModel
          class_resolver :stage_class, "Ecoportal::API::V2::Page::Stage"

          self.klass = :stage_class

          def get_by_name(name)
            find do |stage|
              stage.name.strip.downcase == name.to_s.strip.downcase
            end
          end

          def ordered_stages
            stages.each_with_index.sort_by do |stage, index|
              (stage.ordering >= 9999) ? [index, index] : [stage.ordering, index]
            end.map(&:first)
          end

        end
      end
    end
  end
end
